import * as minecraft from 'mojang-minecraft';

class Loc{
	constructor (location){
		this.location=new minecraft.Location(Math.floor(location.x),Math.floor(location.y),Math.floor(location.z)),
		this.x=Math.floor(location.x),
		this.y=Math.floor(location.y),
        this.z=Math.floor(location.z),
        this.string=`§4X${this.x} §aY${this.y} §9Z${this.z}§a`
	}
	closer(target,locations){
		let res=[];
		for(let loc of locations){
			let distance=Math.sqrt(Math.pow(target.x - loc.x, 2) + Math.pow(target.y - loc.y, 2) + Math.pow(target.z - loc.z, 2));
			res.push(distance);
		}
		return res.indexOf(Math.min(...res));
	}
}

class hacer{
	static parse(element=null){
		if(element){
			let title={rawtext: []};
		    for(let key in element){
			    let state = [{ translate: `state.${key}.name` }, { text: "§a§o " }, { translate: `${element[key]}` } ,{ text: "§r\n" }];
			    ((key in {id:null,nameTag:null}) && element[key]) ? title["rawtext"].push(...state) : undefined;
			    (key == "location") ? [state[2]={translate: `${new Loc(element[key]).string}`}, title["rawtext"].push(...state)] : undefined;
			    (key == "getComponents") ? [element[key]().filter(function(e){if(e.id=="minecraft:health") {return [state[0]={translate: "state.health.name"}, state[2]={translate: `§4${e.current}§9/§a${e.value}§a` }, title["rawtext"].push(...state) ]} })] : undefined;
			    (key == "permutation" && (element["id"].split(":")[0] == "minecraft")) ? [element[key].getAllProperties().map(function(e){return [state[0]={text: `${e.name.replace(/_/g," ")}`}, state[2]={text: `${e.value}`}, title["rawtext"].push(...state) ]})] : undefined;
			    (key == "permutation" && (element["id"].split(":")[0] != "minecraft")) ? [state[0]={translate: "state.getTags.name"}, state[2]={text: `${element["getTags"]()}`}, title["rawtext"].push(...state)] : undefined;
			}
			title["rawtext"].push(...[{text: "§o§9"}, {translate: `pack.${element["id"].split(":")[0]}.name`}, {text: "§r"}]);
			return JSON.stringify(title);
		}
	}
}
var config={
	ePath: "textures/WITE/",
	bPath: "textures/BLOCKS/",
	loc: new Loc(new minecraft.Location(0,0,0)),
	eRaycast: new minecraft.EntityRaycastOptions(),
	bRaycast: new minecraft.BlockRaycastOptions()
}
config["eRaycast"].maxDistance = config["bRaycast"].maxDistance = 7;
config["bRaycast"].includeLiquidBlocks = false;
config["bRaycast"].includePassableBlocks = true;
minecraft.world.events.tick.subscribe(() => {
	let players = minecraft.world.getPlayers();
	for(let p of players){
		let entidades= p.getEntitiesFromViewVector(config["eRaycast"]);
		let bloque=p.getBlockFromViewVector(config["bRaycast"]);
		if((bloque === null) && entidades.length<=0) return {}
		else if((bloque) && entidades.length<=0) return { viewB: p.runCommand(`title @s actionbar ${config["bPath"] + bloque.type.id.split(":")[1]}`), estado: p.runCommand(`titleraw @s title ${hacer.parse(bloque)}`) }
		else if((bloque === null) && entidades.length>0) return { viewE: p.runCommand(`title @s actionbar ${config["ePath"] + entidades[0].id.split(":")[1]}`), estado: p.runCommand(`titleraw @s title ${hacer.parse(entidades[0])}`) }
		else if(config["loc"].closer(p.location,[entidades[0].location,bloque.location]) == 1) return { viewB: p.runCommand(`title @s actionbar ${config["bPath"] + bloque.type.id.split(":")[1]}`), estado: p.runCommand(`titleraw @s title ${hacer.parse(bloque)}`) }
		else return { viewE: p.runCommand(`title @s actionbar ${config["ePath"] + entidades[0].id.split(":")[1]}`), estado: p.runCommand(`titleraw @s title ${hacer.parse(entidades[0])}`) }
	}
});